# coding: utf-8

"""
    Isilon SDK

    Isilon SDK - Language bindings for the OneFS API  # noqa: E501

    OpenAPI spec version: 6
    Contact: sdk@isilon.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class CertificateServerItem(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'certificate_key_path': 'str',
        'certificate_path': 'str',
        'default': 'bool',
        'description': 'str'
    }

    attribute_map = {
        'certificate_key_path': 'certificate_key_path',
        'certificate_path': 'certificate_path',
        'default': 'default',
        'description': 'description'
    }

    def __init__(self, certificate_key_path=None, certificate_path=None, default=None, description=None):  # noqa: E501
        """CertificateServerItem - a model defined in Swagger"""  # noqa: E501

        self._certificate_key_path = None
        self._certificate_path = None
        self._default = None
        self._description = None
        self.discriminator = None

        self.certificate_key_path = certificate_key_path
        self.certificate_path = certificate_path
        if default is not None:
            self.default = default
        if description is not None:
            self.description = description

    @property
    def certificate_key_path(self):
        """Gets the certificate_key_path of this CertificateServerItem.  # noqa: E501

        Local path to the certificate key that is to be imported.  # noqa: E501

        :return: The certificate_key_path of this CertificateServerItem.  # noqa: E501
        :rtype: str
        """
        return self._certificate_key_path

    @certificate_key_path.setter
    def certificate_key_path(self, certificate_key_path):
        """Sets the certificate_key_path of this CertificateServerItem.

        Local path to the certificate key that is to be imported.  # noqa: E501

        :param certificate_key_path: The certificate_key_path of this CertificateServerItem.  # noqa: E501
        :type: str
        """
        if certificate_key_path is None:
            raise ValueError("Invalid value for `certificate_key_path`, must not be `None`")  # noqa: E501

        self._certificate_key_path = certificate_key_path

    @property
    def certificate_path(self):
        """Gets the certificate_path of this CertificateServerItem.  # noqa: E501

        Local path to the certificate that is to be imported.  # noqa: E501

        :return: The certificate_path of this CertificateServerItem.  # noqa: E501
        :rtype: str
        """
        return self._certificate_path

    @certificate_path.setter
    def certificate_path(self, certificate_path):
        """Sets the certificate_path of this CertificateServerItem.

        Local path to the certificate that is to be imported.  # noqa: E501

        :param certificate_path: The certificate_path of this CertificateServerItem.  # noqa: E501
        :type: str
        """
        if certificate_path is None:
            raise ValueError("Invalid value for `certificate_path`, must not be `None`")  # noqa: E501

        self._certificate_path = certificate_path

    @property
    def default(self):
        """Gets the default of this CertificateServerItem.  # noqa: E501

        Boolean identifying if a certificate is the default certificate.The default certificate is used as the fallback when no other certificates match a TLS enabled service's particular criteria. There must always be a configured default certificate.  # noqa: E501

        :return: The default of this CertificateServerItem.  # noqa: E501
        :rtype: bool
        """
        return self._default

    @default.setter
    def default(self, default):
        """Sets the default of this CertificateServerItem.

        Boolean identifying if a certificate is the default certificate.The default certificate is used as the fallback when no other certificates match a TLS enabled service's particular criteria. There must always be a configured default certificate.  # noqa: E501

        :param default: The default of this CertificateServerItem.  # noqa: E501
        :type: bool
        """

        self._default = default

    @property
    def description(self):
        """Gets the description of this CertificateServerItem.  # noqa: E501

        Description field associated with a certificate provided for administrative convenience.  # noqa: E501

        :return: The description of this CertificateServerItem.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this CertificateServerItem.

        Description field associated with a certificate provided for administrative convenience.  # noqa: E501

        :param description: The description of this CertificateServerItem.  # noqa: E501
        :type: str
        """

        self._description = description

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CertificateServerItem):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
